#!/usr/bin/perl

# Perl Guestbook v1.1 
# 2008-2011 (C) Alexander Yanitsky 
# web site: janicky.com                          
# e-mail: janickiy@mail.ru
# ICQ: 305-972 

use GD;
use DBI;
use POSIX;
use CGI::Carp qw(fatalsToBrowser);
use CGI qw(param header);

use Constants;
  
print header("image/gif");
  
use ConnectDB;
  
my $id_session = param('id_session');
    
my $SECURITY_HEIGHT      = 55;      #  image height
my $SECURITY_WIDTH       = 130;     #  image width
my $SECURITY_NUM_GENSIGN = 4;       #  Number of characters, which you need to enter
my $path_fonts           = "font";  # path to font
my $SECURITY_IMAGE_TYPE  = "gif";   # possible image's formats: gif, jpeg, png
  
my $SECURITY_FONT_SIZE = ($SECURITY_HEIGHT/(($SECURITY_HEIGHT/$SECURITY_WIDTH)*7));
  
$im = new GD::Image($SECURITY_WIDTH,$SECURITY_HEIGHT);
my @LETTERS = (0..9);
  
my @FONTS = ();
  
$i = 0;
opendir (ETC, $path_fonts);
    
foreach $filename (readdir(ETC))
{ 
   if($filename =~ /.ttf/i)
   { 
      $FONTS[$i]=$filename;
      $i++;
   } 
}
  
close (ETC);
  
$white = $im->colorAllocate(255,255,255);
  
if($SECURITY_IMAGE_TYPE eq 'gif' or $SECURITY_IMAGE_TYPE eq 'png')
{
   $im->transparent(255,255,255);
   $im->interlaced('true');
}
  
for($l = 0; $l<($SECURITY_HEIGHT)/(($SECURITY_HEIGHT)/4);$l++)
{
   &InitColors($im); 
   $im->line(0,($SECURITY_HEIGHT)/2*(rand(20)/10),$SECURITY_WIDTH,($SECURITY_HEIGHT)/2*(rand(20)/10),$color);
}
  
my @size = (($SECURITY_FONT_SIZE*1.5-2)..($SECURITY_FONT_SIZE*1.5+2));
 
if($i>0)
{
   $x = '';
   my @angle = (-50..50);
   my @h_rand = (($SECURITY_HEIGHT*1.3*3)/5 + rand($SECURITY_HEIGHT*0.02),($SECURITY_HEIGHT*1.3*3)/5 + rand($SECURITY_HEIGHT*0.02));
   @x_rand = (-(rand($SECURITY_WIDTH*0.01)),(rand($SECURITY_WIDTH*0.01)));
   $securityCode = "";
 
   for($d = 0; $d<$SECURITY_NUM_GENSIGN; $d++)
   {
      &InitColors($im);
      $letter = $LETTERS[int(rand(@LETTERS))];
	 
      if($x eq '') { $x = ($SECURITY_WIDTH*0.7)/$SECURITY_NUM_GENSIGN+$x_rand[int(rand(@x_rand))]; }
      else { $x = $x + ($SECURITY_WIDTH*0.7)/$SECURITY_NUM_GENSIGN+$x_rand[int(rand(@x_rand))]; }
	 
      $font = "$path_fonts/$FONTS[int(rand(@FONTS))]";
      $im->stringFT($color, $font, $size[int(rand(@size))], $angle[rand(@angle)]/100, $x, $h_rand[int(rand(@h_rand))], $letter);
	 
      $securityCode .= $letter;
   }
}
else
{
   $x = '';
   my @angle = (-50..50);
   my @h_rand = (($SECURITY_HEIGHT*2.1)/5 + rand($SECURITY_HEIGHT*0.02),($SECURITY_HEIGHT*2.1)/5 + rand($SECURITY_HEIGHT*0.02));
   my @x_rand = (-(rand($SECURITY_WIDTH*0.01)),(rand($SECURITY_WIDTH*0.01)));
   $securityCode = "";
	
   &InitColors($im);
	 
   for($d = 0; $d<$SECURITY_NUM_GENSIGN; $d++)
   {
      $letter = $LETTERS[int(rand(@LETTERS))];
	  
      if($x eq '') { $x = ($SECURITY_WIDTH*0.7)/$SECURITY_NUM_GENSIGN+$x_rand[int(rand(@x_rand))]; }
      else { $x = $x + ($SECURITY_WIDTH*0.7)/$SECURITY_NUM_GENSIGN+$x_rand[int(rand(@x_rand))]; }
	  
      $im->string(gdGiantFont, $x, $h_rand[int(rand(@h_rand))], $letter, $color);
   }  
}
  
$time = strftime("%Y-%m-%d %I:%M:%S", localtime);

if($securityCode ne '' and $id_session ne '')
{
   my $search = $dbh->prepare("SELECT count(*) FROM ".Constants::DB_CAPTCHA." WHERE id_session LIKE '$id_session'");
   $search->execute();
   $count = int($search->fetchrow_arrayref()->[0]);	
   
   $search->finish();
	
   $delete = $dbh->do("DELETE FROM ".Constants::DB_CAPTCHA." WHERE time < '$time' - INTERVAL '20' MINUTE");
	
   if($count == 0)
   {
      $insert = $dbh->do("INSERT INTO ".Constants::DB_CAPTCHA." VALUES (0,'$id_session','$securityCode','$time')");
   }
   else
   {
      $update = $dbh->do("UPDATE ".Constants::DB_CAPTCHA." SET securityCode = '$securityCode', time = '$time' WHERE id_session = '$id_session'");
   }	
}
  
binmode(STDOUT);

print $im->$SECURITY_IMAGE_TYPE;
  
$dbh->disconnect();
  
sub InitColors
{
   my($im) = $_[0];
   
   @FIGURES = (20..200);

   $color = $im->colorAllocate($FIGURES[int(rand(@FIGURES))],$FIGURES[int(rand(@FIGURES))],$FIGURES[int(rand(@FIGURES))]);
}
